package de.intevation.flys.importer;

import de.intevation.flys.model.TimeInterval;

import org.hibernate.Session;
import org.hibernate.Query;

import java.util.List;
import java.util.Date;

import org.apache.log4j.Logger;

public class ImportTimeInterval
{
    private static Logger log = Logger.getLogger(ImportTimeInterval.class);

    protected Date startTime;
    protected Date stopTime;

    protected TimeInterval peer;

    public ImportTimeInterval() {
    }

    public ImportTimeInterval(Date startTime, Date stopTime) {
        this.startTime = startTime;
        this.stopTime  = stopTime;
    }

    public Date getStartTime() {
        return startTime;
    }

    public void setStartTime(Date startTime) {
        this.startTime = startTime;
    }

    public Date getStopTime() {
        return stopTime;
    }

    public void setStopTime(Date stopTime) {
        this.stopTime = stopTime;
    }

    public TimeInterval getPeer() {
        if (peer == null) {
            Session session = Importer.sessionHolder.get();
            Query query = session.createQuery(
                "from TimeInterval where startTime=:a and stopTime=:b");
            query.setParameter("a", startTime);
            query.setParameter("b",  stopTime);
            List<TimeInterval> intervals = query.list();
            if (intervals.isEmpty()) {
                peer = new TimeInterval(startTime, stopTime);
                session.save(peer);
            }
            else {
                peer = intervals.get(0);
            }
        }
        return peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
